package com.ejie.ab79.control.procedimientos;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;

import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.model.procedimientos.Aplicaciones;
import com.ejie.ab79.model.procedimientos.Direcciones;
import com.ejie.ab79.model.procedimientos.Procedimientos;
import com.ejie.ab79.service.procedimientos.ProcedimientosService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ProcedimientosController  
 * 
 *  
 */

@Controller
@RequestMapping(value = "/procedimientos")

public class ProcedimientosController {

	private static final Logger logger = LoggerFactory.getLogger(ProcedimientosController.class);

	@Autowired
	private ProcedimientosService procedimientosService;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idProcedimiento
	 *            Integer
	 * @return Procedimientos Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idProcedimiento}", method = RequestMethod.GET)
	public @ResponseBody Procedimientos get(@PathVariable Integer idProcedimiento) {
		Procedimientos procedimientos = new Procedimientos();
		procedimientos.setIdProcedimiento(idProcedimiento);
		procedimientos = this.procedimientosService.find(procedimientos);
		ProcedimientosController.logger.info("[GET - findBy_PK] : Obtener Procedimientos por PK");
		return procedimientos;
	}

	@RequestMapping(value = "/procedimientoSancionesTurismo", method = RequestMethod.GET)
	public @ResponseBody Integer getProcedimientoSancionesTurismo() {
		Procedimientos procedimientos = new Procedimientos();
		procedimientos = this.procedimientosService.findByProcedureId(Constantes.PROCEDURE_ID_SANCIONES_TURISMO);
		ProcedimientosController.logger.info("[GET - findBy_PK] : Obtener Procedimientos por PK");
		return procedimientos.getIdProcedimiento();
	}

	@RequestMapping(value = "/procedimientoSancionesComercio", method = RequestMethod.GET)
	public @ResponseBody Integer getProcedimientoSancionesComercio() {
		Procedimientos procedimientos = new Procedimientos();
		procedimientos = this.procedimientosService.findByProcedureId(Constantes.PROCEDURE_ID_SANCIONES_COMERCIO);
		ProcedimientosController.logger.info("[GET - findBy_PK] : Obtener Procedimientos por PK");
		return procedimientos.getIdProcedimiento();
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterProcedimientos
	 *            Procedimientos Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @return List<Procedimientos> Lista de objetos correspondientes a la
	 *         busqueda realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<Procedimientos> getAll(@ModelAttribute Procedimientos filterProcedimientos,
			@RequestParam(value = "direccion.idDireccion", required = false) Integer idDireccion) {
		ProcedimientosController.logger.info("[GET - find_ALL] : Obtener Procedimientos por filtro");

		if (idDireccion != null) {
			Direcciones direccion = new Direcciones();
			direccion.setIdDireccion(idDireccion);
			filterProcedimientos.setDirecciones(direccion);
		}

		return this.procedimientosService.findAll(filterProcedimientos, null);
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterProcedimientos
	 *            Procedimientos Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @return List<Procedimientos> Lista de objetos correspondientes a la
	 *         busqueda realizada.
	 */
	@RequestMapping(value = "/expedienteInspeccion", method = RequestMethod.GET)
	public @ResponseBody List<Procedimientos> getAllExpedienteInspeccion(
			@ModelAttribute Procedimientos filterProcedimientos,
			@RequestParam(value = "direccion.idDireccion", required = false) Integer idDireccion) {
		ProcedimientosController.logger.info("[GET - find_ALL] : Obtener Procedimientos por filtro");

		if (idDireccion != null) {
			Direcciones direccion = new Direcciones();
			direccion.setIdDireccion(idDireccion);
			filterProcedimientos.setDirecciones(direccion);
		}

		Aplicaciones aplicacion = new Aplicaciones();
		aplicacion.setCodAplicacion(Constantes.AB79);
		filterProcedimientos.setAplicacion(aplicacion);

		return this.procedimientosService.findAll(filterProcedimientos, null);
	}

	@RequestMapping(value = "/procedimientosAplicacion", method = RequestMethod.GET)
	public @ResponseBody List<Procedimientos> getAllProcedimientosAplicacion(
			@ModelAttribute Procedimientos filterProcedimientos) {
		ProcedimientosController.logger
				.info("[GET - getAllProcedimientosAplicacion] : Obtener Procedimientos por filtro");

		Aplicaciones aplicacion = new Aplicaciones();
		aplicacion.setCodAplicacion(Constantes.AB79);
		filterProcedimientos.setAplicacion(aplicacion);
		return this.procedimientosService.findAllProcedimientosAplicacion(filterProcedimientos);
	}

	@RequestMapping(value = "/procedimientosWS", method = RequestMethod.GET)
	public @ResponseBody List<Procedimientos> getAllWS() {
		ProcedimientosController.logger.info("[GET - getAllWS] : Obtener Procedimientos WS");
		return this.procedimientosService.obtenerProcedimientosInicioOficio();
	}
	
	@RequestMapping(value = "/obtenerProcedimientosInicioOficioByInspeccion/{idInspeccion}", method = RequestMethod.GET)
	public @ResponseBody List<Procedimientos> obtenerProcedimientosInicioOficioByInspeccion(@PathVariable Integer idInspeccion) {
		ProcedimientosController.logger.info("[GET - obtenerProcedimientosInicioOficioByInspeccion] : Obtener Procedimientos");
		return this.procedimientosService.obtenerProcedimientosInicioOficioByInspeccion(idInspeccion);
	}

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit(Model model) {
		ProcedimientosController.logger.info("[GET - View] : procedimientos");
		return "procedimientos";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterProcedimientos
	 *            Procedimientos Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<Procedimientos> Dto que contiene el resultado
	 *         del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<Procedimientos> filter(
			@RequestJsonBody(param = "filter") Procedimientos filterProcedimientos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ProcedimientosController.logger.info("[POST - filter] : Obtener Procedimientoss");
		return this.procedimientosService.filter(filterProcedimientos, tableRequestDto, false);
	}

	/**
	 * Operacion de busqueda del componente RUP_TABLE.
	 * 
	 * @param filterProcedimientos
	 *            Procedimientos Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param searchProcedimientos
	 *            Procedimientos Bean que contiene los parametros de busqueda a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la búsqueda.
	 * @return TableRowDto<Procedimientos> Dto que contiene el resultado de la
	 *         busqueda realizada por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/search", method = RequestMethod.POST)
	public @ResponseBody List<TableRowDto<Procedimientos>> search(
			@RequestJsonBody(param = "filter") Procedimientos filterProcedimientos,
			@RequestJsonBody(param = "search") Procedimientos searchProcedimientos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ProcedimientosController.logger.info("[POST - search] : Buscar Procedimientoss");
		return this.procedimientosService.search(filterProcedimientos, searchProcedimientos, tableRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterProcedimientos
	 *            Procedimientos Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(
			@RequestJsonBody(param = "filter") Procedimientos filterProcedimientos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ProcedimientosController.logger
				.info("[POST - search] : [POST - removeMultiple] : Eliminar multiples Procedimientoss");
		this.procedimientosService.removeMultiple(filterProcedimientos, tableRequestDto, false);
		ProcedimientosController.logger.info("All entities correctly deleted!");

		return tableRequestDto.getMultiselection().getSelectedIds();
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE - JERARQUIA
	 */

	/**
	 * Operacion de filtrado del componente RUP_TABLE para presentar los
	 * registros mediante visualizacion jerarquica.
	 * 
	 * @param filterProcedimientos
	 *            Procedimientos Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<Procedimientos>> Dto que contiene
	 *         el resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquia/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<Procedimientos>> jerarquia(
			@RequestJsonBody(param = "filter") Procedimientos filterProcedimientos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ProcedimientosController.logger.info("[POST - jerarquia] : Obtener Procedimientoss jerarquia");
		return this.procedimientosService.jerarquia(filterProcedimientos, tableRequestDto, false);
	}

	/**
	 * Recupera los hijos de los registros desplegados en la visualizacion
	 * jerarquica.
	 * 
	 * @param filterProcedimientos
	 *            Procedimientos Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<Procedimientos>> Dto que contiene
	 *         el resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquiaChildren", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<Procedimientos>> jerarquiaChildren(
			@RequestJsonBody(param = "filter") Procedimientos filterProcedimientos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ProcedimientosController.logger.info("[POST - jerarquia] : Obtener Procedimientoss jerarquia - Hijos");
		return this.procedimientosService.jerarquiaChildren(filterProcedimientos, tableRequestDto);
	}

	/**
	 * EXPORTERS
	 */

	@RequestMapping(value = "/clipboardReport", method = RequestMethod.POST)
	protected @ResponseBody List<Procedimientos> getClipboardReport(
			@RequestJsonBody(param = "filter") Procedimientos filterProcedimientos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ProcedimientosController.logger.info("[POST - clipboardReport] : : Copiar multiples usuarios");
		return this.procedimientosService.getMultiple(filterProcedimientos, tableRequestDto, false);
	}

}
